/*
 * StichingImage.h
 *
 *  Created on: Dec 10, 2013
 *      Author: truongnt
 */

#ifndef STICHINGIMAGE_H_
#define STICHINGIMAGE_H_

#include "opencv2/core/core.hpp"
#include "ExtractorDescriptorMatcher.h"
#include <vector>


#include <string>
#include <iostream>

namespace producer_consumer_thread {
using namespace cv;

class PerspectiveMat
{
public:
	cv::Mat src;
	cv::Mat dst, dst_msk;
	cv::Rect RectConner;
	cv::Point2f topleftRelative;

	void warpPerspective2(Mat src, Mat &dst, Mat H12, Point RectConner);
	bool create(cv::Mat Src, cv::Mat H12);
	void drawToFinalImage(cv::Mat H12, cv::Mat &final, cv::Mat &final_msk);
};

class StitchingImage {

public:
	StitchingImage();
	virtual ~StitchingImage();

public:
	void ApplyImage(cv::Mat img_1, cv::Mat img_2);

public:
	cv::Mat imgFinalResult, imgAfterRANSAC;
	cv::Mat DetailedImg1, DetailedImg2;
	cv::Point2f OrientationVector;

protected:
	cv::Rect BoundaryRectColorSpace;
	cv::Point2f drawOrientationVector(cv::Mat &result, const std::vector<cv::KeyPoint> &keypoints1, const std::vector<cv::KeyPoint> &keypoints2,
			const std::vector< cv::DMatch > &matches,
			const std::vector<char> &matchesMask = *new std::vector<char>());

	cv::Mat drawMatchedPoints(cv::Point2f &orientationVector, cv::Mat img1, cv::Mat img2,
			std::vector<cv::KeyPoint> keypoints1, std::vector<cv::KeyPoint> keypoints2,
			std::vector< cv::DMatch > matches,
			std::vector<char> matchesMask = *new std::vector<char>());

	cv::Mat getHomographyMatrix3x3(cv::Mat img_1, cv::Mat img_2, cv::Mat &imgAfterRANSAC, cv::Point2f &orientationVector);

};

} /* namespace producer_thread */
#endif /* STICHINGIMAGE_H_ */
