// Copyright (C) 2013 by - FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
//                       - Institut Eurécom
//                       - Télécom ParisTech
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of demoARDrone.
// 
// demoARDrone is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
// License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
// version.
// 
// demoARDrone is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with demoARDrone. If not, see 
// <http://www.gnu.org/licenses/>.


// fly like an insect => DOES NOT WORK CURRENTLY !!!
// =================================================

#pragma once

#include "appBase.h"
#include "hawaii/common/tracker.h"
#include <auto_ptr.h>

// forward declaration
class Matcher ;

// derived from base drone application
class DroneAppInsectoid : public DroneAppBase {
	
	// custom initialization of wrapped classes
	public:
	DroneAppInsectoid() ;
	protected:
   std::auto_ptr< Matcher > matcherPtr ;
   
   // targets for closed-loop control
	protected:
   hawaii::common::Tracker1DPT1 headingTarget,   // [rad] in [-Pi,Pi), top-view counter-clockwise positive
	                             altitudeTarget ; // [m], positive during flight
	
	// generate targets from forward camera images
	protected:
	virtual void processImageFront( const cv_bridge::CvImage imageFront ) override ;
	
	// perform higher-rate closed loop control with on-board measurements
	protected:
	virtual void processNavdata( const ardrone_autonomy::Navdata navdata ) override ;
} ;
