/*
 * drone_consumer.cpp
 *
 *  Created on: Aug 20, 2013
 *      Author: truongnt
 */

#include "drone_consumer.h"
#include "hawaii/common/helpers.h"
#include <opencv2/imgproc/imgproc.hpp>

#include <unistd.h>
#include <dirent.h>
#include <sys/types.h> // for opendir(), readdir(), closedir()
#include <sys/stat.h> // for stat()
namespace producer_consumer_thread {

//SimulateDroneProducerClient
DroneConsumerClient::DroneConsumerClient(int n,
		const std::string& port,
		const std::string& hostLap2, const std::string& portLap2)
:		network_base_infomation(n, port, hostLap2, portLap2) {

}

DroneConsumerClient::~DroneConsumerClient() {
	// TODO Auto-generated destructor stub
}

void DroneConsumerClient::operator ()() {
	try {
	    boost::asio::io_service io_service;
	    //-------------------
	    server s(io_service, utilities::StringToNumber(this->mportSrc), 2);
	    client2 c(io_service, this->mhostDst, this->mportDst);

	    //http://stackoverflow.com/questions/16365561/boost-threading-and-mutexes-in-a-functor
	    //explain while we need to use boost::ref, because copy not allow in boost::mutex.
	    boost::thread t_client2 = boost::thread(&client2::process_sender, boost::ref(c) ) ;
	    t_client2.detach();

	    while (!Gb_SystemState.check(SystemState::closedState)) {
	    	io_service.poll();
	    	//std::cout<<"DroneConsumerClient check state"<<std::endl;
	    	//boost::this_thread::sleep(boost::posix_time::milliseconds(50));
	    }

		s.socket_cancel();
		c.socket_cancel();
	} catch (std::exception& e)
	{
		printing("[ERROR] DroneConsumerClient::operator (): " + std::string(e.what()));
	}
}

} /* namespace producer_thread */
