/*
 * imageCapture.cpp
 *
 *  Created on: 21 nov. 2013
 *      Author: nguyen
 */

#include "imageCapture.h"
#include "hawaii/common/optimization.h"
#include "hawaii/common/helpers.h"
#include <sstream>

imageCapture::imageCapture(int max_img_arg, int delay_arg):
	DroneAppBase( false ),
	img_captured(0) {
	this->max_img = max_img_arg;
	this->delay = delay_arg;
	this->img_process_counter=0;
}

imageCapture::~imageCapture() {
	// TODO Auto-generated destructor stub
}

void imageCapture::processImageFront( const cv_bridge::CvImage imageFront ) {
	cv::Mat visualization = imageFront.image ;

	HAWAII_IMSHOW( visualization ) ;

	if( this->engaged && this->img_process_counter < this->max_img ) {
		if ( this->img_process_counter % delay == 0 ) {
			std::ostringstream oss;
			oss << "data/bach/image" << this->img_captured << ".jpg"; //saving path
			cv::imshow("saved image", visualization);
			cv::imwrite( oss.str(), visualization ); //save the image
			this->img_captured++;
		}
		this->img_process_counter++;
	}

	//reset img_process_counter for further captures
	if( !this->engaged && this->img_process_counter!=0) {
		this->img_process_counter = 0;
	}

	cv::waitKey( 1 ) ; //necessary to give time to display images

} // processImageFront
