/*
 * ExtractorDescriptorMatcher.cpp
 *
 *  Created on: Jan 28, 2014
 *      Author: truongnt
 */

#include "ExtractorDescriptorMatcher.h"

using namespace std;
using namespace cv;

DetectorExtractorMatcher::DetectorExtractorMatcher() {
	// TODO Auto-generated constructor stub

}

DetectorExtractorMatcher::~DetectorExtractorMatcher() {
	// TODO Auto-generated destructor stub
}


void DetectKeyPointsSURF(
		//input
		Mat img_1, Mat img_2,
		//output
		std::vector<KeyPoint> &keypoints_1, std::vector<KeyPoint> &keypoints_2,
		Mat &descriptors_1, Mat &descriptors_2) {
	hawaii::tic();

	int minHessian = 400;

	//SurfFeatureDetector detector( minHessian );
	Ptr<FeatureDetector> detector = FeatureDetector::create("SURF");

//	detector.detect( img_1, keypoints_1 );
//	detector.detect( img_2, keypoints_2 );

	detector->detect( img_1, keypoints_1 );
	detector->detect( img_2, keypoints_2 );

	//-- Step 2: Calculate descriptors (feature vectors)
	SurfDescriptorExtractor extractor;

	extractor.compute( img_1, keypoints_1, descriptors_1 );
	extractor.compute( img_2, keypoints_2, descriptors_2 );

	logging1("SURF", utilities::DoubleToString(hawaii::toc()));
}

//---------------------------------------------------------------------------------------------------------
//detect, extract, match, match filter in general
//enum { NONE_FILTER = 0, CROSS_CHECK_FILTER = 1 };
//
//static int getMatcherFilterType( const string& str )
//{
//    if( str == "NoneFilter" )
//        return NONE_FILTER;
//    if( str == "CrossCheckFilter" )
//        return CROSS_CHECK_FILTER;
//    CV_Error(CV_StsBadArg, "Invalid filter name");
//    return -1;
//}

void DetectKeyPoints(const std::string &strDetector, const std::string &strDescriptor, //std::string strMatcher, std::string strMatcherFilter,
		//input
		const Mat &img1, const Mat &img2,
		//output
		std::vector<KeyPoint> &keypoints1, std::vector<KeyPoint> &keypoints2,
		Mat &descriptors1, Mat &descriptors2) {
	cout << "< Creating detector, descriptor extractor and descriptor matcher ..." << endl;
	Ptr<FeatureDetector> detector = FeatureDetector::create( strDetector );
	Ptr<DescriptorExtractor> descriptorExtractor = DescriptorExtractor::create( strDescriptor );
//	Ptr<DescriptorMatcher> descriptorMatcher = DescriptorMatcher::create( strMatcher );
//	int mactherFilterType = getMatcherFilterType( strMatcherFilter );
	if( detector.empty() || descriptorExtractor.empty() )// || descriptorMatcher.empty()  )
	{
		cout << "Can not create detector or descriptor exstractor or descriptor matcher of given types" << endl;
		return;
	}

	detector->detect( img1, keypoints1 );
	cout << keypoints1.size() << " points" << endl << ">" << endl;

	detector->detect( img2, keypoints2 );
	cout << keypoints2.size() << " points" << endl << ">" << endl;

//	descriptors1 = cv::Mat::zeros(1, 1, CV_8U);
//	descriptors2 = cv::Mat::zeros(1, 1, CV_8U);

	std::cout<<"before extractor"<<std::endl;
	descriptorExtractor->compute( img1, keypoints1, descriptors1 );
	descriptorExtractor->compute( img2, keypoints2, descriptors2 );
}

//---------------------------------------------------------------------------------------------------------
//+supported detector:
//    "FAST" – FastFeatureDetector
//    "STAR" – StarFeatureDetector
//    "SIFT" – SIFT (nonfree module)
//    "SURF" – SURF (nonfree module)
//    "ORB" – ORB
//    "BRISK" – BRISK
//    "MSER" – MSER
//    "GFTT" – GoodFeaturesToTrackDetector
//    "HARRIS" – GoodFeaturesToTrackDetector with Harris detector enabled
//    "Dense" – DenseFeatureDetector
//    "SimpleBlob" – SimpleBlobDetector
//+supported extractor
//	"SIFT" – SIFT
//	"SURF" – SURF
//	"BRIEF" – BriefDescriptorExtractor
//	"BRISK" – BRISK
//	"ORB" – ORB
//	"FREAK" – FREAK

void DetectorExtractorMatcher::detectExtractDescriptor(
		const std::string &strDetector, const std::string &strDescriptor, //std::string strMatcher, std::string strMatcherFilter,
		//input
		const Mat &img1, const Mat &img2,
		//output
		std::vector<KeyPoint> &keypoints1, std::vector<KeyPoint> &keypoints2,
		Mat &descriptors1, Mat &descriptors2) {

//	if(descriptors1.type()!=CV_32F) {
//		descriptors1.convertTo(descriptors1, CV_32F);
//	}
//
//	if(descriptors2.type()!=CV_32F) {
//		descriptors2.convertTo(descriptors2, CV_32F);
//	}

	//for default keypoints detector and descriptor, TODO we can implement other detector with different parameters later
	//for example "SURF", "SURF",...
	DetectKeyPoints(strDetector, strDescriptor, img1, img2, keypoints1, keypoints2, descriptors1, descriptors2);
}


static void crossCheckMatching( DescriptorMatcher *descriptorMatcher,//Ptr<DescriptorMatcher>& descriptorMatcher,
                         const Mat& descriptors1, const Mat& descriptors2,
                         vector<DMatch>& filteredMatches12, int knn=1 )
{
    filteredMatches12.clear();
    vector<vector<DMatch> > matches12, matches21;
    descriptorMatcher->knnMatch( descriptors1, descriptors2, matches12, knn );
    descriptorMatcher->knnMatch( descriptors2, descriptors1, matches21, knn );
    for( size_t m = 0; m < matches12.size(); m++ )
    {
        bool findCrossCheck = false;
        for( size_t fk = 0; fk < matches12[m].size(); fk++ )
        {
            DMatch forward = matches12[m][fk];

            for( size_t bk = 0; bk < matches21[forward.trainIdx].size(); bk++ )
            {
                DMatch backward = matches21[forward.trainIdx][bk];
                if( backward.trainIdx == forward.queryIdx )
                {
                    filteredMatches12.push_back(forward);
                    findCrossCheck = true;
                    break;
                }
            }
            if( findCrossCheck ) break;
        }
    }
}

//for different type of descriptor
//http://stackoverflow.com/questions/7232651/how-does-opencv-orb-feature-detector-work
void DetectorExtractorMatcher::matchFeature(
		//change matcher depend on descriptor!
		const std::string &strDetector, const std::string &strDescriptor, const std::string &strMatcher,
		//input
		const std::vector<KeyPoint> &keypoints_1, const std::vector<KeyPoint> &keypoints_2, const Mat &descriptors_1, const Mat &descriptors_2,
		//output
		std::vector< DMatch > &matches
		) {
	try {

		if (strDescriptor == "ORB" || strDescriptor == "BRISK") {
			//working with uchar descriptor
			if ( descriptors_1.empty() )
				cvError(0,"MatchFinder","1st descriptor empty",__FILE__,__LINE__);
			if ( descriptors_2.empty() )
				cvError(0,"MatchFinder","2nd descriptor empty",__FILE__,__LINE__);

			//http://stackoverflow.com/questions/11565255/opencv-flann-with-orb-descriptors
			if(descriptors_1.type()!=CV_8U) {
				descriptors_1.convertTo(descriptors_1, CV_8U);
			}

			if(descriptors_2.type()!=CV_8U) {
				descriptors_2.convertTo(descriptors_2, CV_8U);
			}

			cout<<"before FlannBasedMatcher"<<endl;
			cv::BFMatcher matcher(NORM_HAMMING, true);
			//FlannBasedMatcher matcher;
			matcher.match( descriptors_1, descriptors_2, matches );
		}
		else if (strDescriptor == "SIFT" || strDescriptor == "SURF") {
			if ( descriptors_1.empty() )
				cvError(0,"MatchFinder","1st descriptor empty",__FILE__,__LINE__);
			if ( descriptors_2.empty() )
				cvError(0,"MatchFinder","2nd descriptor empty",__FILE__,__LINE__);

			//http://stackoverflow.com/questions/11565255/opencv-flann-with-orb-descriptors
			if(descriptors_1.type()!=CV_32F) {
				descriptors_1.convertTo(descriptors_1, CV_32F);
			}

			if(descriptors_2.type()!=CV_32F) {
				descriptors_2.convertTo(descriptors_2, CV_32F);
			}

			cout<<"before FlannBasedMatcher"<<endl;
			//cv::BFMatcher matcher(cv::NORM_L2, true);
			FlannBasedMatcher matcher;
			//matcher.match( descriptors_1, descriptors_2, matches );
			crossCheckMatching(&matcher, descriptors_1, descriptors_2, matches, 1);
		}
	}
	catch (std::exception& e)
	{
		std::cerr << "StichingImage::ApplyImage " << e.what() << std::endl;
	}
}
