/*
 * ExtractorDescriptorMatcher.h
 *
 *  Created on: Jan 28, 2014
 *      Author: truongnt
 */

#ifndef EXTRACTORDESCRIPTORMATCHER_H_
#define EXTRACTORDESCRIPTORMATCHER_H_

#include "opencv2/core/core.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/features2d/features2d.hpp"
#include "opencv2/nonfree/nonfree.hpp"

#include <vector>
#include <string>
#include <iostream>

#include "hawaii/common/timer.h"
#include "hawaii/common/tracker.h"

#include "base/basic_function.h"

class DetectorExtractorMatcher {
public:
	DetectorExtractorMatcher();
	virtual ~DetectorExtractorMatcher();

	static void detectExtractDescriptor(
			const std::string &strDetector, const std::string &strDescriptor, //std::string strMatcher, std::string strMatcherFilter,
					//input
					const cv::Mat &img1, const cv::Mat &img2,
					//output
					std::vector<cv::KeyPoint> &keypoints1, std::vector<cv::KeyPoint> &keypoints2,
					cv::Mat &descriptors1, cv::Mat &descriptors2);
	static void matchFeature(
			const std::string &strDetector, const std::string &strDescriptor, const std::string &strMatcher,
			//input
			const std::vector<cv::KeyPoint> &keypoints_1, const std::vector<cv::KeyPoint> &keypoints_2, const cv::Mat &descriptors_1, const cv::Mat &descriptors_2,
			//output
			std::vector< cv::DMatch > &matches);
};

#endif /* EXTRACTORDESCRIPTORMATCHER_H_ */
