/*
 * sender_receiver.cpp
 *
 *  Created on: Aug 13, 2013
 *      Author: truongnt
 */

#include "sender_receiver.h"

//------------------------------------------------------------------------
//client1
void client1::process_sender() {
	try {
		while (true) {
			//stop connection when
			// Step 1: User press ESC button or remote press ESC button
			// Step 2: Set global variable Gb_SystemState to closedState
			// Step 3: Check state in sender and receiver according to each Drone
			//  For example: check in function session_server1::process_receiver and client 1 for Drone 1
			//               check in function session_server2::process_receiver and client 2 for Drone 2
			MessageData msg;
			if (Gb_SystemState.check(SystemState::closedState)) {
				this->do_close();
				return;
			}

			//printing("client1::process_sender");
			if (IsProcessingMessage_.check(true)) {
				boost::this_thread::sleep(boost::posix_time::milliseconds(25));
				continue;
			}

			if (connectionState_.check(ConnectionState::Step2)) {
				printing("Step 2");

				msg = MessageData::createMessage(Command::ClientSendInfoToServer);
				this->asyn_sendMessage(msg);

				connectionState_.set(ConnectionState::activeConnection);//back to step 3 and wait for comming connection
				IsProcessingMessage_.set(true);
			}

			if (connectionState_.check(ConnectionState::activeConnection)) {
				//printing("activeConnection");
				if (GloQueueCommand.try_pop(msg)) {
					CommandIndex_++;
					msg.mCommandIndex = CommandIndex_;

					this->asyn_sendMessage(msg);
					IsProcessingMessage_.set(true);
				}
			}
		}
	}
	catch (std::exception& e)
	{
		std::cerr << "client1::process_sender " << e.what() << std::endl;
	}
}

//------------------------------------------------------------------------
//client2
void client2::process_sender() {
	try {
		//stop connection when
		// Step 1: User press ESC button or remote press ESC button
		// Step 2: Set global variable Gb_SystemState to closedState
		// Step 3: Check state in sender and receiver according to each Drone
		//  For example: check in function session_server1::process_receiver and client 1 for Drone 1
		//               check in function session_server2::process_receiver and client 2 for Drone 2
		MessageData msg;
		while (true) {
			//printing("client2::process_sender");

			if (Gb_SystemState.check(SystemState::closedState)) { return; }

			if (IsProcessingMessage_.check(true)) {
				boost::this_thread::sleep(boost::posix_time::milliseconds(25));
				continue;
			}

			if (connectionState_.check(ConnectionState::Step2)) {
				printing("Step 2");

				msg = MessageData::createMessage(Command::ClientSendInfoToServer);
				this->asyn_sendMessage(msg);

				connectionState_.set(ConnectionState::activeConnection);//back to step 3 and wait for comming connection
				IsProcessingMessage_.set(true);
			}
			else if (connectionState_.check(ConnectionState::activeConnection)) {
				//printing("activeConnection");
				if (GloQueueData.try_pop(msg)) {
					this->asyn_sendMessage(msg);
					IsProcessingMessage_.set(true);
				}
			}
		}
	}
	catch (std::exception& e)
	{
		std::cerr << "client2::process_sender " << e.what() << std::endl;
	}
}
