// Copyright (C) 2013 by FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of libHawaii.
// 
// libHawaii is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
// License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
// version.
// 
// libHawaii is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with libHawaii. If not, see 
// <http://www.gnu.org/licenses/>.


// compare floating point numbers for equality
// ===========================================

#pragma once

#include <cmath>
#include <limits>
     
namespace hawaii {

// use a value-dependent tolerance
// developer note: adapted from www.codingstandard.com/rule/5-7-1-do-not-write-code-that-expects-floating-point-calculations-to-yield-exact-results
bool equal( const float  a,
            const float  b ) {
	return std::fabs( a - b ) <= ( std::numeric_limits< float  >::epsilon() * ( std::fabs( a ) + std::fabs( b ) ) ) ;
}
bool equal( const double a,
            const double b ) {
	return std::fabs( a - b ) <= ( std::numeric_limits< double >::epsilon() * ( std::fabs( a ) + std::fabs( b ) ) ) ;
}

} // namespace "hawaii"
